;compiler macros for built in functions can optionally be loaded
;optional, cuz they destroy certain lisptronic properties of the functions
;such as posibility of rebinding and having existing functions use new binding
;(load "src/cmacro.scm")

;multiple value bind
(define-macro (mvb b x . e)
 `(call-with-values
    (lambda () ,x)
    (lambda ,b . ,e)))

(define (write-lf x)
  (write x)
  (newline))

(display "welcome to tunalisp repl")
(newline)
(let loop ()
  (write-char #\>)
  (let ((x (read)))
    (if (not (eof-object? x))
      (mvb rtn (eval x (interaction-environment))
        (for-each write-lf rtn)
        (loop)))))

